package sb.finder;

import java.awt.Component;
import java.io.File;
import java.util.Properties;
import java.util.ResourceBundle;

import javax.swing.JFileChooser;
import olivamail.core.common.ComUtils;

public class Context {

	public static String homeDir = null;
	
	public static String myName = "SBFinder";
	
	public static final String myPackagePath = "/sb/finder/";

	private static String FileDlgOpenPath = null;

	private static String FileDlgSavePath = null;

	private static Properties settings = new Properties();	
	
	public static void setFIleDlgOpenPath(String path) {
		FileDlgOpenPath = path;
	}
	
	public static File dirOpenDialog(Component parent) {
		JFileChooser jFileChooser1 = new JFileChooser();
		jFileChooser1.setDialogTitle(Strings.getString("fileOpen"));
		jFileChooser1.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);		
		if (Context.FileDlgOpenPath == null)
			Context.FileDlgOpenPath = "";
		jFileChooser1.setSelectedFile(new File(ComUtils
				.nvl(Context.FileDlgOpenPath)));
		if (JFileChooser.CANCEL_OPTION == jFileChooser1.showOpenDialog(parent))
			return null;
		File file = jFileChooser1.getSelectedFile();
		if (file != null)
			Context.FileDlgOpenPath = file.getPath();
		return file;
	}	
			
	public static File fileSaveDialog(Component parent, String fileName) {		
		JFileChooser jFileChooser1 = new JFileChooser();
		jFileChooser1.setDialogTitle(Strings.getString("fileSave"));
		if (Context.FileDlgSavePath == null)
			Context.FileDlgSavePath = "";
		
		fileName = ComUtils.nvl(fileName);
				
		jFileChooser1.setSelectedFile(new File(Context.FileDlgSavePath + fileName));
		if (JFileChooser.CANCEL_OPTION == jFileChooser1.showSaveDialog(parent))
			return null;
		File file = jFileChooser1.getSelectedFile();

		if (file != null && file.exists()) {
			switch (AlertDialog
					.showConfirmDialog(Strings.getString("fileOverwrite"),
							AlertDialog.YES_NO_CANCEL_OPTION)) {
			case AlertDialog.YES_OPTION:
				break;
			case AlertDialog.NO_OPTION:
				file = fileSaveDialog(parent, file.getPath());
				break;
			case AlertDialog.CANCEL_OPTION:
				file = null;
				break;
			}
		}		
		
		if (file != null)
			Context.FileDlgSavePath = file.getParent() + File.separator;
				
		return file;
	}	
		
	public static File getSettingsFile() {
		return new File(homeDir + "conf/settings.properties");		
	}
		
	public static void loadSettings() throws Exception {
		ResourceBundle bundle = null;
		try {
			bundle = ResourceBundle.getBundle("settings",
					java.util.Locale.US);
		} catch (java.util.MissingResourceException mre) {
			mre.printStackTrace();
			return;
		}
		for (java.util.Enumeration e = bundle.getKeys(); e.hasMoreElements();) {
			String key = (String) e.nextElement();
			String value = olivamail.core.common.ComUtils.getStringInternals(bundle
					.getString(key), "utf-8");
			settings.setProperty(key, value);
		}						
	}
	
	public static String getProperty(String name) {		
		return settings.getProperty(name);	
	}
	
}
